#!/usr/bin/perl

#/*******************
# * Tan, Yen Hock
# ******************/

# prints sequence of pdb file
# ARGV[0] - pdb file
# ARGV[1] - chain ID (optional)
# ARGV[2] - starting residue number (optional)
# ARGV[3] - ending residue number (optional)
$flag=0;
%modres= ();
if(scalar(@ARGV) eq 1) {
    open IN, "<$ARGV[0]" or die "ERROR: $!\n";
    $ARGV[0]=~ /pdb(\w{4})\.ent/;
    $name=lc($1);
    print ">$name\n";
    $i=0;
    while(<IN>) 
    {
	if($i eq 80)
	{
		print "\n";
		$i=0;
	}
	$line = $_;
	if(substr($line, 0, 6) eq "MODRES")
	{
	    $num=substr($line, 19, 3);
	    $num=~ /\s*(\S*)/;
	    $name=$1;
	    $modres{$name}=substr($line, 24, 3);
	}
	if((substr($line, 0, 4) eq "ATOM") || ((substr($line, 0, 6) eq "HETATM") && (substr($line, 17, 3) ne "HOH")))
	{
	    if((substr($line, 13, 2) eq "CA") && ((substr($line, 16, 1) eq " ") || (substr($line, 16, 1) eq "A") || (substr($line, 16, 1) eq "1"))) 
	    {
		$res_name = substr($line, 17, 3);
		if(substr($line, 0, 6) eq "HETATM")
		{
		    $num=substr($line, 23, 3);
		    $num=~ /\s*(\S*)/;
		    $name=$1;
		    $res_name=$modres{$name};
		}
		if($res_name eq "ALA") {print "A";}
		elsif($res_name eq "VAL") {print "V";}
		elsif($res_name eq "LEU") {print "L";}
		elsif($res_name eq "ILE") {print "I";}
		elsif($res_name eq "PRO") {print "P";}
		elsif($res_name eq "MET") {print "M";}
		elsif($res_name eq "PHE") {print "F";}
		elsif($res_name eq "TRP") {print "W";}
		elsif($res_name eq "GLY") {print "G";}
		elsif($res_name eq "SER") {print "S";}
		elsif($res_name eq "THR") {print "T";}
		elsif($res_name eq "CYS") {print "C";}
		elsif($res_name eq "ASN") {print "N";}
		elsif($res_name eq "GLN") {print "Q";}
		elsif($res_name eq "TYR") {print "Y";}
		elsif($res_name eq "ASP") {print "D";}
		elsif($res_name eq "GLU") {print "E";}
		elsif($res_name eq "LYS") {print "K";}
		elsif($res_name eq "ARG") {print "R";}
		elsif($res_name eq "HIS") {print "H";}
		else {print "X";}
                $flag=1;
		$i++;
	    }
	}
	if((substr($line, 0, 6) eq "ENDMDL") && ($flag == 1))
	{
		last;
	}
    }
    close IN;
}
elsif(scalar(@ARGV) eq 2) {
    open IN, "<$ARGV[0]" or die "ERROR: $!\n";
    $ARGV[0]=~ /pdb(\w{4})\.ent/;
    $name=lc($1);
    print ">$name\n";
    $i=0;
    while(<IN>) {
    	if($i eq 80)
	{
		print "\n";
		$i=0;
	}
	$line = $_;
	if(substr($line, 0, 6) eq "MODRES")
	{
	    $chainid=substr($line, 16, 1);
	    $num=substr($line, 19, 3);
	    $num=~ /\s*(\S*)/;
	    $name=$1.$chainid;
	    $modres{$name}=substr($line, 24, 3);
	}
	if((substr($line, 0, 4) eq "ATOM") || ((substr($line, 0, 6) eq "HETATM") && (substr($line, 17, 3) ne "HOH"))) 
	{
	    if((substr($line, 13, 2) eq "CA") && ((substr($line, 16, 1) eq " ") || (substr($line, 16, 1) eq "A") || (substr($line, 16, 1) eq "1"))) 
	    {
		$chain_id = substr($line, 21, 1);
		$chain = $ARGV[1];
		$chain =~ tr/[a-z]/[A-Z]/;
		if($chain_id eq $chain) 
		{
		    $res_name = substr($line, 17, 3);
		    if(substr($line, 0, 6) eq "HETATM")
		    {
			$num=substr($line, 23, 3);
			$num=~ /\s*(\S*)/;
			$name=$1.$chain;
			$res_name=$modres{$name};
		    }
		    if($res_name eq "ALA") {print "A";}
		    elsif($res_name eq "VAL") {print "V";}
		    elsif($res_name eq "LEU") {print "L";}
		    elsif($res_name eq "ILE") {print "I";}
		    elsif($res_name eq "PRO") {print "P";}
		    elsif($res_name eq "MET") {print "M";}
		    elsif($res_name eq "PHE") {print "F";}
		    elsif($res_name eq "TRP") {print "W";}
		    elsif($res_name eq "GLY") {print "G";}
		    elsif($res_name eq "SER") {print "S";}
		    elsif($res_name eq "THR") {print "T";}
		    elsif($res_name eq "CYS") {print "C";}
		    elsif($res_name eq "ASN") {print "N";}
		    elsif($res_name eq "GLN") {print "Q";}
		    elsif($res_name eq "TYR") {print "Y";}
		    elsif($res_name eq "ASP") {print "D";}
		    elsif($res_name eq "GLU") {print "E";}
		    elsif($res_name eq "LYS") {print "K";}
		    elsif($res_name eq "ARG") {print "R";}
		    elsif($res_name eq "HIS") {print "H";}
		    else {print "X";}
                    $flag=1;
		    $i++;
		}
	    }
	}
	if((substr($line, 0, 6) eq "ENDMDL") && ($flag == 1))
	{
		last;
	}
    }
    close IN;
}
elsif(scalar(@ARGV) eq 4) {
    open IN, "<$ARGV[0]" or die "ERROR: $!\n";
    $ARGV[0]=~ /pdb(\w{4})\.ent/;
    $name=lc($1);
    print ">$name\n";
    $i=0;
    while(<IN>) {
    	if($i eq 80)
	{
		print "\n";
		$i=0;
	}
	$line = $_;
	if(substr($line, 0, 6) eq "MODRES")
	{
	    $chainid=substr($line, 16, 1);
	    $num=substr($line, 19, 3);
	    $num=~ /\s*(\S*)/;
	    $name=$1.$chainid;
	    $modres{$name}=substr($line, 24, 3);
	}
	if((substr($line, 0, 4) eq "ATOM") || ((substr($line, 0, 6) eq "HETATM") && (substr($line, 17, 3) ne "HOH"))) 
	{
	    if((substr($line, 13, 2) eq "CA") && ((substr($line, 16, 1) eq " ") || (substr($line, 16, 1) eq "A") || (substr($line, 16, 1) eq "1"))) 
	    {
		$chain_id = substr($line, 21, 1);
		$chain = $ARGV[1];
		if($chain eq "-" || $chain eq "_") 
		{
		    $chain = $chain_id;
		}
		else 
		{
		    $chain =~ tr/[a-z]/[A-Z]/;
		}
		if($chain_id eq $chain) 
		{
		    $res = substr($line, 22, 4);
		    $res =~ s/\s+//g;
		    if($res >= $ARGV[2] && $res <= $ARGV[3]) 
		    {
			$res_name = substr($line, 17, 3);
			if(substr($line, 0, 6) eq "HETATM")
			{
			    $num=substr($line, 23, 3);
			    $num=~ /\s*(\S*)/;
			    $name=$1.$chain;
			    $res_name=$modres{$name};
			}
			if($res_name eq "ALA") {print "A";}
			elsif($res_name eq "VAL") {print "V";}
			elsif($res_name eq "LEU") {print "L";}
			elsif($res_name eq "ILE") {print "I";}
			elsif($res_name eq "PRO") {print "P";}
			elsif($res_name eq "MET") {print "M";}
			elsif($res_name eq "PHE") {print "F";}
			elsif($res_name eq "TRP") {print "W";}
			elsif($res_name eq "GLY") {print "G";}
			elsif($res_name eq "SER") {print "S";}
			elsif($res_name eq "THR") {print "T";}
			elsif($res_name eq "CYS") {print "C";}
			elsif($res_name eq "ASN") {print "N";}
			elsif($res_name eq "GLN") {print "Q";}
			elsif($res_name eq "TYR") {print "Y";}
			elsif($res_name eq "ASP") {print "D";}
			elsif($res_name eq "GLU") {print "E";}
			elsif($res_name eq "LYS") {print "K";}
			elsif($res_name eq "ARG") {print "R";}
			elsif($res_name eq "HIS") {print "H";}
			else {print "X";}
                        $flag=1;
			$i++;
		    }
		}
	    }
	}
	if((substr($line, 0, 6) eq "ENDMDL") && ($flag == 1))
	{
		last;
	}
    }
    close IN;
}
else {
    print "Usage: PDBSeq.pl <pdb file> <chain ID> <start> <end>";
}
print "\n";
